diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -8799,15 +4330,261 @@ test_malloc_constraints ()
 
   model.add_constraint (p, NE_EXPR, null_ptr, NULL);
 
-  /* Adding the constraint should have cleared m_possibly_null.  */
-  ASSERT_FALSE (sym_reg->m_possibly_null);
-
   ASSERT_CONDITION_TRUE (model, p, NE_EXPR, null_ptr);
   ASSERT_CONDITION_FALSE (model, p, EQ_EXPR, null_ptr);
   ASSERT_CONDITION_TRUE (model, q, NE_EXPR, null_ptr);
   ASSERT_CONDITION_FALSE (model, q, EQ_EXPR, null_ptr);
 }
 
+/* Smoketest of getting and setting the value of a variable.  */
+
+static void
+test_var ()
+{
+  /* "int i;"  */
+  tree i = build_global_decl ("i", integer_type_node);
+
+  tree int_17 = build_int_cst (integer_type_node, 17);
+  tree int_m3 = build_int_cst (integer_type_node, -3);
+
+  region_model_manager mgr;
+  region_model model (&mgr);
+
+  const region *i_reg = model.get_lvalue (i, NULL);
+  ASSERT_EQ (i_reg->get_kind (), RK_DECL);
+
+  /* Reading "i" should give a symbolic "initial value".  */
+  const svalue *sval_init = model.get_rvalue (i, NULL);
+  ASSERT_EQ (sval_init->get_kind (), SK_INITIAL);
+  ASSERT_EQ (sval_init->dyn_cast_initial_svalue ()->get_region (), i_reg);
+  /* ..and doing it again should give the same "initial value".  */
+  ASSERT_EQ (model.get_rvalue (i, NULL), sval_init);
+
+  /* "i = 17;".  */
+  model.set_value (i, int_17, NULL);
+  ASSERT_EQ (model.get_rvalue (i, NULL),
+	     model.get_rvalue (int_17, NULL));
+
+  /* "i = -3;".  */
+  model.set_value (i, int_m3, NULL);
+  ASSERT_EQ (model.get_rvalue (i, NULL),
+	     model.get_rvalue (int_m3, NULL));
+
+  /* Verify get_offset for "i".  */
+  {
+    region_offset offset = i_reg->get_offset ();
+    ASSERT_EQ (offset.get_base_region (), i_reg);
+    ASSERT_EQ (offset.get_bit_offset (), 0);
+  }
+}
+
+static void
+test_array_2 ()
+{
+  /* "int arr[10];"  */
+  tree tlen = size_int (10);
+  tree arr_type
+    = build_array_type (integer_type_node, build_index_type (tlen));
+  tree arr = build_global_decl ("arr", arr_type);
+
+  /* "int i;"  */
+  tree i = build_global_decl ("i", integer_type_node);
+
+  tree int_0 = build_int_cst (integer_type_node, 0);
+  tree int_1 = build_int_cst (integer_type_node, 1);
+
+  tree arr_0 = build4 (ARRAY_REF, integer_type_node,
+		       arr, int_0, NULL_TREE, NULL_TREE);
+  tree arr_1 = build4 (ARRAY_REF, integer_type_node,
+		       arr, int_1, NULL_TREE, NULL_TREE);
+  tree arr_i = build4 (ARRAY_REF, integer_type_node,
+		       arr, i, NULL_TREE, NULL_TREE);
+
+  tree int_17 = build_int_cst (integer_type_node, 17);
+  tree int_42 = build_int_cst (integer_type_node, 42);
+  tree int_m3 = build_int_cst (integer_type_node, -3);
+
+  region_model_manager mgr;
+  region_model model (&mgr);
+  /* "arr[0] = 17;".  */
+  model.set_value (arr_0, int_17, NULL);
+  /* "arr[1] = -3;".  */
+  model.set_value (arr_1, int_m3, NULL);
+
+  ASSERT_EQ (model.get_rvalue (arr_0, NULL), model.get_rvalue (int_17, NULL));
+  ASSERT_EQ (model.get_rvalue (arr_1, NULL), model.get_rvalue (int_m3, NULL));
+
+  /* Overwrite a pre-existing binding: "arr[1] = 42;".  */
+  model.set_value (arr_1, int_42, NULL);
+  ASSERT_EQ (model.get_rvalue (arr_1, NULL), model.get_rvalue (int_42, NULL));
+
+  /* Verify get_offset for "arr[0]".  */
+  {
+    const region *arr_0_reg = model.get_lvalue (arr_0, NULL);
+    region_offset offset = arr_0_reg->get_offset ();
+    ASSERT_EQ (offset.get_base_region (), model.get_lvalue (arr, NULL));
+    ASSERT_EQ (offset.get_bit_offset (), 0);
+  }
+
+  /* Verify get_offset for "arr[1]".  */
+  {
+    const region *arr_1_reg = model.get_lvalue (arr_1, NULL);
+    region_offset offset = arr_1_reg->get_offset ();
+    ASSERT_EQ (offset.get_base_region (), model.get_lvalue (arr, NULL));
+    ASSERT_EQ (offset.get_bit_offset (), INT_TYPE_SIZE);
+  }
+
+  /* "arr[i] = i;" - this should remove the earlier bindings.  */
+  model.set_value (arr_i, i, NULL);
+  ASSERT_EQ (model.get_rvalue (arr_i, NULL), model.get_rvalue (i, NULL));
+  ASSERT_EQ (model.get_rvalue (arr_0, NULL)->get_kind (), SK_UNKNOWN);
+
+  /* "arr[0] = 17;" - this should remove the arr[i] binding.  */
+  model.set_value (arr_0, int_17, NULL);
+  ASSERT_EQ (model.get_rvalue (arr_0, NULL), model.get_rvalue (int_17, NULL));
+  ASSERT_EQ (model.get_rvalue (arr_i, NULL)->get_kind (), SK_UNKNOWN);
+}
+
+/* Smoketest of dereferencing a pointer via MEM_REF.  */
+
+static void
+test_mem_ref ()
+{
+  /*
+    x = 17;
+    p = &x;
+    *p;
+   */
+  tree x = build_global_decl ("x", integer_type_node);
+  tree int_star = build_pointer_type (integer_type_node);
+  tree p = build_global_decl ("p", int_star);
+
+  tree int_17 = build_int_cst (integer_type_node, 17);
+  tree addr_of_x = build1 (ADDR_EXPR, int_star, x);
+  tree offset_0 = build_int_cst (integer_type_node, 0);
+  tree star_p = build2 (MEM_REF, integer_type_node, p, offset_0);
+
+  region_model_manager mgr;
+  region_model model (&mgr);
+
+  /* "x = 17;".  */
+  model.set_value (x, int_17, NULL);
+
+  /* "p = &x;".  */
+  model.set_value (p, addr_of_x, NULL);
+
+  const svalue *sval = model.get_rvalue (star_p, NULL);
+  ASSERT_EQ (sval->maybe_get_constant (), int_17);
+}
+
+/* Test for a POINTER_PLUS_EXPR followed by a MEM_REF.
+   Analogous to this code:
+     void test_6 (int a[10])
+     {
+       __analyzer_eval (a[3] == 42); [should be UNKNOWN]
+       a[3] = 42;
+       __analyzer_eval (a[3] == 42); [should be TRUE]
+     }
+   from data-model-1.c, which looks like this at the gimple level:
+       # __analyzer_eval (a[3] == 42); [should be UNKNOWN]
+       int *_1 = a_10(D) + 12;   # POINTER_PLUS_EXPR
+       int _2 = *_1;             # MEM_REF
+       _Bool _3 = _2 == 42;
+       int _4 = (int) _3;
+       __analyzer_eval (_4);
+
+       # a[3] = 42;
+       int *_5 = a_10(D) + 12;   # POINTER_PLUS_EXPR
+       *_5 = 42;                 # MEM_REF
+
+       # __analyzer_eval (a[3] == 42); [should be TRUE]
+       int *_6 = a_10(D) + 12;   # POINTER_PLUS_EXPR
+       int _7 = *_6;             # MEM_REF
+       _Bool _8 = _7 == 42;
+       int _9 = (int) _8;
+       __analyzer_eval (_9);  */
+
+static void
+test_POINTER_PLUS_EXPR_then_MEM_REF ()
+{
+  tree int_star = build_pointer_type (integer_type_node);
+  tree a = build_global_decl ("a", int_star);
+  tree offset_12 = build_int_cst (size_type_node, 12);
+  tree pointer_plus_expr = build2 (POINTER_PLUS_EXPR, int_star, a, offset_12);
+  tree offset_0 = build_int_cst (integer_type_node, 0);
+  tree mem_ref = build2 (MEM_REF, integer_type_node,
+			 pointer_plus_expr, offset_0);
+  region_model_manager mgr;
+  region_model m (&mgr);
+
+  tree int_42 = build_int_cst (integer_type_node, 42);
+  m.set_value (mem_ref, int_42, NULL);
+  ASSERT_EQ (m.get_rvalue (mem_ref, NULL)->maybe_get_constant (), int_42);
+}
+
+/* Verify that malloc works.  */
+
+static void
+test_malloc ()
+{
+  tree int_star = build_pointer_type (integer_type_node);
+  tree p = build_global_decl ("p", int_star);
+  tree n = build_global_decl ("n", integer_type_node);
+  tree n_times_4 = build2 (MULT_EXPR, size_type_node,
+			   n, build_int_cst (size_type_node, 4));
+
+  region_model_manager mgr;
+  test_region_model_context ctxt;
+  region_model model (&mgr);
+
+  /* "p = malloc (n * 4);".  */
+  const svalue *size_sval = model.get_rvalue (n_times_4, &ctxt);
+  const region *reg = model.create_region_for_heap_alloc (size_sval);
+  const svalue *ptr = mgr.get_ptr_svalue (int_star, reg);
+  model.set_value (model.get_lvalue (p, &ctxt), ptr, &ctxt);
+  // TODO: verify dynamic extents
+}
+
+/* Verify that alloca works.  */
+
+static void
+test_alloca ()
+{
+  auto_vec <tree> param_types;
+  tree fndecl = make_fndecl (integer_type_node,
+			     "test_fn",
+			     param_types);
+  allocate_struct_function (fndecl, true);
+
+
+  tree int_star = build_pointer_type (integer_type_node);
+  tree p = build_global_decl ("p", int_star);
+  tree n = build_global_decl ("n", integer_type_node);
+  tree n_times_4 = build2 (MULT_EXPR, size_type_node,
+			   n, build_int_cst (size_type_node, 4));
+
+  region_model_manager mgr;
+  test_region_model_context ctxt;
+  region_model model (&mgr);
+
+  /* Push stack frame.  */
+  const region *frame_reg
+    = model.push_frame (DECL_STRUCT_FUNCTION (fndecl),
+			NULL, &ctxt);
+  /* "p = alloca (n * 4);".  */
+  const svalue *size_sval = model.get_rvalue (n_times_4, &ctxt);
+  const region *reg = model.create_region_for_alloca (size_sval);
+  ASSERT_EQ (reg->get_parent_region (), frame_reg);
+  const svalue *ptr = mgr.get_ptr_svalue (int_star, reg);
+  model.set_value (model.get_lvalue (p, &ctxt), ptr, &ctxt);
+  // TODO: verify dynamic extents
+
+  /* Verify that the pointers to the alloca region are replaced by
+     poisoned values when the frame is popped.  */
+  model.pop_frame (NULL, NULL, &ctxt);
+  ASSERT_EQ (model.get_rvalue (p, &ctxt)->get_kind (), SK_POISONED);
+}
+
 /* Run all of the selftests within this file.  */
 
 void
@@ -8815,25 +4592,35 @@ analyzer_region_model_cc_tests ()
 {
   test_tree_cmp_on_constants ();
   test_dump ();
-  test_dump_2 ();
-  test_dump_3 ();
+  test_struct ();
+  test_array_1 ();
   test_get_representative_tree ();
   test_unique_constants ();
-  test_svalue_equality ();
-  test_region_equality ();
-  test_purging_by_criteria ();
-  test_purge_unused_svalues ();
+  test_unique_unknowns ();
+  test_initial_svalue_folding ();
+  test_unaryop_svalue_folding ();
+  test_binop_svalue_folding ();
+  test_sub_svalue_folding ();
+  test_descendent_of_p ();
   test_assignment ();
   test_compound_assignment ();
   test_stack_frames ();
   test_get_representative_path_var ();
-  test_canonicalization_1 ();
+  test_equality_1 ();
   test_canonicalization_2 ();
   test_canonicalization_3 ();
   test_canonicalization_4 ();
   test_state_merging ();
   test_constraint_merging ();
+  test_widening_constraints ();
+  test_iteration_1 ();
   test_malloc_constraints ();
+  test_var ();
+  test_array_2 ();
+  test_mem_ref ();
+  test_POINTER_PLUS_EXPR_then_MEM_REF ();
+  test_malloc ();
+  test_alloca ();
 }
 
 } // namespace selftest
